(* Routine pour le debogage *)
#open"syntaxe_commune";;
#open"compilateur_commun";;

let print_couple (n,p) =
  print_string "(";
  print_int n;
  print_string ",";
  print_int p;
  print_string ")"
;;

let print_const = function
   Int n    -> print_int n
 | Float f  -> print_float f
 | String s -> print_string ("\""^s^"\"")
 | Char c   -> print_char c
 | Bool c   -> print_string (if c then "true" else "false")
 | Indefini -> print_string "_INDEFINI_"
 | Nom id   -> print_string ("Symbole:("^id^")")
 | Unit     -> print_string "()"
;;

let print_prim prim =
  print_string (match prim with
     Plus    -> "+"
   | Moins   -> "-"
   | Fois    -> "*"
   | Divise  -> "/"
   | Egal    -> "="
   | Affiche -> "print")
;;

let affiche_code code =
  for n=0 to (vect_length code) - 1 do
  print_int n;
  print_string ": ";
  begin
    match code.(n) with
      SApplique        -> print_string "Applique"
    | SLambda          -> print_string "Lambda "
    | SFonction n      -> print_string "Fonction ";print_int n
    | SRetour          -> print_string "Retour "
    | SAccede n        -> print_string "Accede ";print_int n
    | SConstante const -> print_string "Const ";print_const const
    | SDepile n        -> print_string "Depile ";print_int n
    | SReserve n       -> print_string "Reserve ";print_int n
    | SLet n           -> print_string "Let ";print_int n
    | SLetrec n        -> print_string "Letrec ";print_int n
    | SSelect c        -> print_string "Select ";print_couple c
    | SModifie n       -> print_string "Modifie ";print_int n
    | SPrimitive prim  -> print_string "Primitive ";print_prim prim
  end;
  print_newline ()
  done
;;

