{
#open "parseur_miniml";;
}

rule Token = parse
    [` ` `\t` `\n`]		{ Token lexbuf }
  | `(`				{ LPAR }
  | `)`				{ RPAR }
  | `=`				{ EQUAL }  
  | `+`				{ PLUS }  
  | `-`				{ MINUS }  
  | `*`				{ TIMES }  
  | `/`				{ DIVIDE }  
  | ":="			{ COLONEQUAL }
  | `\``			{ BACKQUOTE }
  | `;`				{ SEMI }
  | ";;"			{ SEMISEMI }
  | "->"			{ DASHSUP }
  | "false"			{ BOOL false }
  | "true"		       	{ BOOL true }
  | "let"			{ LET }
  | "rec"			{ REC }
  | "and"			{ AND }
  | "in"			{ IN }
  | "if"			{ IF }
  | "then"			{ THEN }
  | "else"			{ ELSE }
  | "fun"			{ FUN }
  | "do"			{ DO }
  | "return"			{ RETURN }
  | eof 			{ EOF }
  | [`a`-`z` `` `` `` `` `` `` `` `` `` `A`-`Z` `_`]
    [`a`-`z` `` `` `` `` `` `` `` `` `` `A`-`Z` `_` `0`-`9` `'`]*
      	       	       	       	{ IDENT (get_lexeme lexbuf) }
  | `-`? [`0`-`9`]+ `.` [`0`-`9`]* ([`e` `E`] [`+` `-`]? [`0`-`9`]+)?
      	       	       	       	{ FLOAT (float_of_string (get_lexeme lexbuf)) }
  | `-`? [`0`-`9`]+		{ INT (int_of_string (get_lexeme lexbuf)) }
  | `\`` _ `\``			{ CHAR (get_lexeme_char lexbuf 1) }
  | `"`				{ try STRING (Chaine lexbuf)
                                  with End_of_file -> EOF }

and Chaine = parse
    `"`				{ "" }
  | `\\` `\\`			{ "\\"^(Chaine lexbuf) }
  | `\\` `n`			{ "\n"^(Chaine lexbuf) }
  | `\\` `"`			{ "\""^(Chaine lexbuf) }
  | `\\` `t`			{ "\t"^(Chaine lexbuf) }
  | `\\` `b`			{ "\b"^(Chaine lexbuf) }
  | _                           { let s=(get_lexeme lexbuf)
                                  in s^(Chaine lexbuf) }
  | eof				{ raise End_of_file }
;;
